| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
PythonScriptingSvc Class Reference

This service handles scripting implemented using Python. More...

`#include <GaudiPython/PythonScriptingSvc.h>`

Inheritance diagram for PythonScriptingSvc:
[legend]
Collaboration diagram for PythonScriptingSvc:
[legend]

## Public Member Functions
| PythonScriptingSvc (const std::string &name, ISvcLocator *svc)
| Standard Constructor. More...
StatusCode | initialize () override
| Initialize the service. [IService::initialize()]. More...
StatusCode | finalize () override
| Finalize the service. [IService::finalize()]. More...
StatusCode | run () override
| Run the service by taking full control. [IRunable::run()]. More...
Public Member Functions inherited from extends< Service, IRunable >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declarePrivateTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Private tool. More...
template<class T >
StatusCode | declarePublicTool (ToolHandle< T > &handle, std::string toolTypeAndName="", bool createIf=true)
| Declare used Public tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Protected Member Functions
| ~PythonScriptingSvc () override
| Destructor. More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Attributes
std::string | m_startupScript
| Startup script. More...

## Additional Inherited Members
Public Types inherited from extends< Service, IRunable >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

This service handles scripting implemented using Python.

Author
  Pere Mato
  David Quarrie

Date
  2001

Definition at line 15 of file PythonScriptingSvc.h.

## Constructor & Destructor Documentation

PythonScriptingSvc::PythonScriptingSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Standard Constructor.

Definition at line 23 of file PythonScriptingSvc.cpp.

25 : base_class( name, svc )
26 {
27 // Declare the startup script Property
28 declareProperty( "StartupScript", m_startupScript = "" );
29 }
PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >::declareProperty
Gaudi::Details::PropertyBase & declareProperty(Gaudi::Details::PropertyBase &prop)
Declare a property.
Definition: PropertyHolder.h:99
extends< Service, IRunable >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
PythonScriptingSvc::m_startupScript
std::string m_startupScript
Startup script.
Definition: PythonScriptingSvc.h:36

PythonScriptingSvc::~PythonScriptingSvc | ( |  | ) |
| override protected

Destructor.

Definition at line 32 of file PythonScriptingSvc.cpp.

32 {}

## Member Function Documentation

StatusCode PythonScriptingSvc::finalize | ( |  | ) |
| override

Finalize the service. [IService::finalize()].

Definition at line 95 of file PythonScriptingSvc.cpp.

97 {
98 // Finalize this specific service
99 StatusCode sc = Service::finalize();
100 if ( sc.isFailure() ) return sc;
101
102 // Shutdown the Python interpreter
103 Py_Finalize();
104 return StatusCode::SUCCESS;
105 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
Service::finalize
StatusCode finalize() override
Definition: Service.cpp:174
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:84
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26

StatusCode PythonScriptingSvc::initialize | ( |  | ) |
| override

Initialize the service. [IService::initialize()].

Definition at line 36 of file PythonScriptingSvc.cpp.

38 {
39 // initialize the Service Base class
40 StatusCode sc = Service::initialize();
41 if ( sc.isFailure() ) return sc;
42
43 // Setup startup script. If none is explicitly specified, then
44 // use the ApplicationMgr JobOptionsPath property as long as
45 // the JobOptionsType property is set to "NONE".
46 if ( m_startupScript.empty() ) {
47 auto prpMgr = serviceLocator()->as<IProperty>();
48 if ( prpMgr ) {
49 Gaudi::Property<std::string> tmp;
50 tmp.assign( prpMgr->getProperty( "JobOptionsType" ) );
51 if ( tmp.value() == "NONE" ) {
52 tmp.assign( prpMgr->getProperty( "JobOptionsPath" ) );
53 m_startupScript = tmp;
54 }
55 }
56 }
57
58 char* progName[] = {const_cast<char*>( "GaudiPython" )};
59
60 // Initialize the Python interpreter. Required.
61 Py_Initialize();
62 // Set argv for Tkinter (needs program name)
63 PySys_SetArgv( 1, progName );
64 // Get the Python version
65 std::string fullversion = Py_GetVersion();
66 std::string version( fullversion, 0, fullversion.find_first_of( ' ' ) );
67 std::string vers( version, 0, version.find_first_of( '.', version.find_first_of( '.' ) + 1 ) );
68 info() << "Python version: [" << vers << "]" << endmsg;
69
70 #if defined( __linux )
71 // This is hack to make global the python symbols
72 // which are needed by the other python modules
73 // (eg. readline, math, etc,) libraries.
74 std::string libname = "libpython" + vers + ".so";
75 dlopen( libname.c_str(), RTLD_GLOBAL | RTLD_LAZY );
76 #endif
77
78 // Startup commands
79 PyRun_SimpleString( "from gaudimodule import *" );
80 PyRun_SimpleString( "g = AppMgr()" );
81 // backward compatibility with SIPython
82 PyRun_SimpleString( "theApp = g" );
83 PyRun_SimpleString( "def Service(n): return g.service(n)" );
84 PyRun_SimpleString( "def Algorithm(n): return g.algorithm(n)" );
85 PyRun_SimpleString( "def Property(n): return g.service(n)" );
86 // For command-line completion (unix only)
87 #if !defined( _WIN32 )
88 PyRun_SimpleString( "import rlcompleter" );
89 PyRun_SimpleString( "rlcompleter.readline.parse_and_bind('tab: complete')" );
90 #endif
91 return StatusCode::SUCCESS;
92 }
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
StatusCode::SUCCESS
Definition: StatusCode.h:30
std::string::empty
T empty(T...args)
Gaudi::Property
Implementation of property with value of concrete type.
Definition: Property.h:314
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:123
ISvcLocator::as
SmartIF< IFace > as()
Definition: ISvcLocator.h:106
StatusCode::isFailure
bool isFailure() const
Test for a status code of FAILURE.
Definition: StatusCode.h:84
std::string
STL class.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:26
PythonScriptingSvc::m_startupScript
std::string m_startupScript
Startup script.
Definition: PythonScriptingSvc.h:36
std::string::find_first_of
T find_first_of(T...args)
std::string::c_str
T c_str(T...args)
Gaudi::Property::assign
bool assign(const Details::PropertyBase &source) override
get the value from another property
Definition: Property.h:596
Gaudi::Property::value
const ValueType & value() const
Backward compatibility (.
Definition: Property.h:475
IProperty
The IProperty is the basic interface for all components which have properties that can be set or get...
Definition: IProperty.h:20
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:292
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244

StatusCode PythonScriptingSvc::run | ( |  | ) |
| override

Run the service by taking full control. [IRunable::run()].

Definition at line 108 of file PythonScriptingSvc.cpp.

110 {
111 if ( !m_startupScript.empty() ) {
112 std::ifstream file{m_startupScript};
113 std::stringstream stream;
114 if ( file ) {
115 std::string buffer;
116 file.seekg( 0, std::ios::end );
117 buffer.reserve( file.tellg() );
118 file.seekg( 0, std::ios::beg );
119 buffer.assign( ( std::istreambuf_iterator<char>{file} ), std::istreambuf_iterator<char>{} );
120 file.close();
121 PyRun_SimpleString( buffer.c_str() );
122 } else {
123 warning() << "Python startup file " << m_startupScript << " not found" << endmsg;
124 }
125 }
126 PyRun_InteractiveLoop( stdin, "\0" );
127 return StatusCode::SUCCESS;
128 }
StatusCode::SUCCESS
Definition: StatusCode.h:30
std::string::empty
T empty(T...args)
std::istreambuf_iterator
std::stringstream
STL class.
std::string
STL class.
CommonMessagingBase::warning
MsgStream & warning() const
shortcut for the method msgStream(MSG::WARNING)
Definition: CommonMessaging.h:120
PythonScriptingSvc::m_startupScript
std::string m_startupScript
Startup script.
Definition: PythonScriptingSvc.h:36
end
auto end(reverse_wrapper< T > &w)
Definition: reverse.h:50
std::string::assign
T assign(T...args)
std::string::c_str
T c_str(T...args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:244
std::ifstream
STL class.
std::string::reserve
T reserve(T...args)

## Member Data Documentation

std::string PythonScriptingSvc::m_startupScript
| private

Startup script.

Definition at line 36 of file PythonScriptingSvc.h.

The documentation for this class was generated from the following files:

- GaudiPython/src/Services/PythonScriptingSvc.h
- GaudiPython/src/Services/PythonScriptingSvc.cpp